package com.xintong.visualinspection.visuallnspection_fjq.controller;

import com.alibaba.fastjson.JSON;
import com.github.pagehelper.PageInfo;
import org.slf4j.LoggerFactory;
import org.springframework.validation.BindingResult;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.annotation.ControllerAdvice;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 文件名：TestController
 * 版本信息：日期：2017/3/30 Copyright 江苏省交通规划设计院 Corporation 2017 版权所有.
 */
@ControllerAdvice
public class BaseController {
	
	private static final org.slf4j.Logger logger = LoggerFactory.getLogger(BaseController.class);

    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnResult(int result_code,String result_desc, Object o){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", result_code);
    	result.put("result_desc", result_desc);
    	result.put("result_data", o);
        return JSON.toJSON(result).toString();
    }
    
    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessResult(String result_desc){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", result_desc);
        return JSON.toJSON(result).toString();
    }
    
    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessResult(){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", "success");
        return JSON.toJSONStringWithDateFormat(result,"yyyy-MM-dd HH:mm");
    }
    
    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessResult(Object o){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", "success");
    	result.put("result_data", o);
        return JSON.toJSONStringWithDateFormat(result,"yyyy-MM-dd HH:mm");
    }
    
    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessResultTime(Object o){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", "success");
    	result.put("result_data", o);
        return JSON.toJSONStringWithDateFormat(result,"yyyy-MM-dd HH:mm:00");
    }
    
    /**
     * 返回前台结果分页结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessPageResult(Object o){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", "success");
    	result.put("result_data", new PageInfo((List)o));
        return JSON.toJSONStringWithDateFormat(result,"yyyy-MM-dd HH:mm");
    }
    
    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessResult(String result_desc, Object o){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", result_desc);
    	result.put("result_data", o);
        return JSON.toJSONStringWithDateFormat(result,"yyyy-MM-dd HH:mm");
    }
    
    /**
     * 返回前台结果结构体
     * @return
     * String
     * @exception
     * @since  1.0.0
     */
    public String returnSuccessResult(String result_desc, Object o, String dateFormat){
    	Map<String,Object> result = new HashMap<>();
    	result.put("result_code", 0);
    	result.put("result_desc", result_desc);
    	result.put("result_data", o);
        return JSON.toJSONStringWithDateFormat(result,dateFormat);
    }
    /** 基于@ExceptionHandler异常处理 *//*
    @ExceptionHandler  
    public String exp(HttpServletRequest request, Exception ex) {  
        // 根据不同错误提示不同的错误  
    	ErrorCode code;
        if(ex instanceof NullPointerException) {  
        	code = new ErrorCode(10001);
        } else if (ex instanceof NumberFormatException) {  
        	code = new ErrorCode(10002);
        } else if (ex instanceof IndexOutOfBoundsException) {  
        	code = new ErrorCode(10003);  
        } else if (ex instanceof ArithmeticException) {  
        	code = new ErrorCode(10004);  
        } else if (ex instanceof FileNotFoundException) {  
        	code = new ErrorCode(10005);  
        } else if (ex instanceof IllegalArgumentException) {  
        	code = new ErrorCode(10006); 
        } else if (ex instanceof HttpMessageNotReadableException) {
        	code = new ErrorCode(10007); 
        } else if (ex instanceof BusinessException) {
        	code = ((BusinessException) ex).getErrCode();
        } else if(ex.getCause() instanceof TooManyResultsException){
        	code = new ErrorCode(10008);
        } else if (ex instanceof MethodArgumentNotValidException) {
        	BindingResult bindingResult = ((MethodArgumentNotValidException) ex).getBindingResult();
        	code = new ErrorCode(20001,getValidatorErrors(bindingResult)); 
        } else{
        	code = new ErrorCode(11000);  
        }
        logger.error(code.getDesc(), ex);
        return returnResult(code.getCode(),code.getDesc(),null);
    }*/
    
    public static String getValidatorErrors(BindingResult bindingResult){
    	StringBuffer sb = new StringBuffer();
    	for(ObjectError err:bindingResult.getAllErrors()){
   		 	sb.append("["+err.getDefaultMessage()+"]");
       	}
       	return sb.toString();
    }
}
